//Servo
#include <Servo.h>
int servoPin = 9;
int servoPos;
Servo myServo;

//Motor
int MOTOR_A1_PIN = 2;
int MOTOR_B1_PIN = 4;
int speedPin = 3;
int motor_speed;

//Ultrasonic Sensor
int trigPin = 12;
int echoPin = 11;
int sensorVal;
int Gradient;
int x = 1000;
int y = 8000;

//Random Number - ChatGPT
int numbers[] = {1, 2, 3, 4, 5};
int index = 0;
int size = sizeof(numbers) / sizeof(numbers[0]);

void setup() {
  Serial.begin(9600);
  pinMode(MOTOR_A1_PIN, OUTPUT);
  pinMode(MOTOR_B1_PIN, OUTPUT);
  pinMode(speedPin, OUTPUT);
  myServo.attach(servoPin);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  shuffleArray(numbers, size);
}

void loop() {
  //Motor Direction
  digitalWrite(MOTOR_A1_PIN, HIGH);
  digitalWrite(MOTOR_B1_PIN, LOW);

  //Ultrasonic Sensor
  digitalWrite(trigPin, LOW);
  delayMicroseconds(50);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(50);
  digitalWrite(trigPin, LOW);
  sensorVal = pulseIn(echoPin, HIGH);
  delay(25);
  Serial.println(sensorVal);

  if (sensorVal > y) {
    analogWrite(speedPin, 180);
  }

  if (sensorVal > x && sensorVal < y) {
    Gradient = map(sensorVal, x, y, 0, 180);
    analogWrite(speedPin, Gradient);
  }

  if (sensorVal < x) {
    if (index < size) {
      int angle = (numbers[index] - 1) * 45; // Map number to angle
      myServo.write(angle);
      Serial.print("Number: ");
      Serial.print(numbers[index]);
      Serial.print(", Servo Angle: ");
      Serial.println(angle);
      delay(3000);
      index++;
      return; // Exit the loop after changing servo position
    } else {
      shuffleArray(numbers, size);
      index = 0;
    }
  }
}

void shuffleArray(int *array, int n) {
  for (int i = n - 1; i > 0; i--) {
    int j = random(0, i + 1);
    int temp = array[i];
    array[i] = array[j];
    array[j] = temp;
  }
}
